set step on
local oRS as ADODB.RecordSet, ;
	oBusiness as Contacts.Customer
***oBusiness = createobject('Contacts.Customer')
set procedure to Contacts
oBusiness = createobject('Customer', 'DataClass')
oRS = createobject('ADODB.RecordSet')
oRS.LockType = 3  && adLockBatchOptimistic 

* Get the ALFKI customer record.

llOK = oBusiness.GetCustomerByID(oRS, 'ALFKI')
if llOK
	messagebox('Found customer ALFKI: ' + trim(oRS.Fields('CompanyName').Value))

* Change the record and try to save it.

	oRS.Fields('Fax').Value = '999-999-9999'
	llOK = oBusiness.Save(oRS)
	if not llOK
		messagebox('Cannot save change to customer ALFKI:' + chr(13) + ;
			chr(13) + oBusiness.ErrorMessage)
	endif not llOK
else
	messagebox('Cannot find customer ALFKI')
endif llOK

* Create a new customer record and save it.

llOK = oBusiness.NewCustomer(oRS)
if llOK
	oRS.Fields('CustomerID').Value  = 'STONE'
	oRS.Fields('CompanyName').Value = 'Stonefield Systems Group Inc.'
	llOK = oBusiness.Save(oRS)
	if llOK
		messagebox('Saved new customer STONE')
	else
		messagebox('Cannot save new record:' + chr(13) + chr(13) + ;
			oBusiness.ErrorMessage)
	endif llOK
else
	messagebox('Cannot create new customer' + chr(13) + chr(13) + ;
			oBusiness.ErrorMessage)
endif llOK

* Ensure it's there.

llOK = oBusiness.GetCustomerByID(oRS, 'STONE')
if llOK
	messagebox('Found customer STONE: ' + trim(oRS.Fields('CompanyName').Value))
else
	messagebox('Cannot find customer STONE')
endif llOK

* Now delete it.

llOK = oBusiness.Delete(oRS)
do case
	case llOK and not oBusiness.GetCustomerByID(oRS, 'STONE')
		messagebox('Customer STONE was deleted')
	case llOK
		messagebox('Customer STONE was supposed to be deleted but was ' + ;
			'still found')
	otherwise
		messagebox('Cannot delete customer STONE:' + chr(13) + chr(13) + ;
			oBusiness.ErrorMessage)
endcase
